<template>
  <v-container>
    <v-layout row justify-center align-center>
      <v-flex xs12>
        <v-toolbar full-width>
          <v-toolbar-title data-cy="title_load_data"
            >Carga de datos</v-toolbar-title
          >
          <div class="flex-grow-1"></div>
          <div data-cy="load_data_buttons">
            <v-btn
              @click="reset(1)"
              color="primary"
              class="mr-1"
              data-cy="paste_data"
            >
              Pega tus datos
            </v-btn>
            <v-btn @click="reset(2)" color="primary" data-cy="upload_file">
              Sube un archivo
            </v-btn>
          </div>
        </v-toolbar>
      </v-flex>
      <v-flex v-show="data.length === 0 && uploadType === 1" xs12 class="mt-3">
        <textarea
          id="excel_data"
          v-model="pastedData"
          @change="parsePastedData()"
          name="excel_data"
          placeholder="Pega tus datos desde Excel"
          class="pl-4 pt-4"
          data-cy="area_paste_data"
        ></textarea>
      </v-flex>
      <v-flex v-show="data.length === 0 && uploadType === 2" xs12 class="mt-3">
        <FilePond
          ref="pond"
          accepted-file-types="text/csv, application/vnd.ms-excel, application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
          data-cy="file_pond"
        />
        <v-btn
          @click="loadFile()"
          color="primary"
          class="float-right"
          data-cy="button_upload_file"
        >
          Subir
        </v-btn>
      </v-flex>
      <v-flex v-show="loading" xs12>
        <v-progress-linear indeterminate color="primary"></v-progress-linear>
      </v-flex>
      <div style="height: 2em"></div>
      <v-flex>
        <div v-if="data.length > 0 && headers.length > 0" style="display: flex">
          <h3 class="table-title">
            Datos
          </h3>
          <v-text-field
            v-model="search"
            prepend-icon="mdi-magnify"
            label="Search"
            hide-details
            full-width
            style="width:50%; display: inline-flex"
          ></v-text-field>
        </div>
        <textarea
          v-if="data.length > 0 && headers.length > 0 && !showTable"
          v-model="dataText"
          name="parsedData"
          style="width: 100%; height: 370px"
        ></textarea>
        <v-data-table
          v-show="data.length > 0 && headers.length > 0"
          v-model="selected"
          :headers="headers"
          :items="data"
          :items-per-page="5"
          :item-key="headers[0] ? headers[0].value : ''"
          :single-select="false"
          :search="search"
          show-select
          class="elevation-1"
          data-cy="table_data"
        ></v-data-table>
        <v-spacer class="pd-2 ma-2"></v-spacer>
        <v-dialog
          v-model="dialogValidate"
          persistent
          max-width="400"
          data-cy="dialog_confirm_save_data"
        >
          <template v-slot:activator="{ on }">
            <v-btn
              v-show="data.length > 0"
              v-on="on"
              color="primary"
              class="float-right"
              data-cy="save_data"
            >
              <v-icon>mdi-content-save</v-icon>Guardar seleccionados
            </v-btn>
          </template>
          <v-card>
            <v-card-title class="headline">Validación</v-card-title>
            <v-card-text>
              Ud valida que los datos son correctos y serán guardados para
              certificar.
            </v-card-text>
            <v-card-actions>
              <div class="flex-grow-1"></div>
              <v-btn
                @click="dialogValidate = false"
                color="primary"
                text
                data-cy="button_cancel"
              >
                Cancelar
              </v-btn>
              <v-btn
                @click="certificate()"
                color="primary"
                text
                data-cy="button_acept"
              >
                Aceptar
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-flex>
    </v-layout>
  </v-container>
</template>
<script>
import { FReader } from '@@/plugins/fileReader'
import vueFilePond from 'vue-filepond' // Import FilePond
import FilePondPluginFileValidateType from 'filepond-plugin-file-validate-type/dist/filepond-plugin-file-validate-type.esm.js' // Import plugins
import 'filepond/dist/filepond.min.css' // Import styles
export default {
  components: {
    // Create FilePond component
    FilePond: vueFilePond(FilePondPluginFileValidateType)
  },
  data() {
    return {
      dialogValidate: false,
      loading: false,
      showTable: true,
      uploadType: 1,
      search: '',
      selected: [],
      empty: [],
      headers: [],
      data: [],
      pastedData: ''
    }
  },
  computed: {
    /** If data-table's data should be displayed in CSV text */
    dataText() {
      return FReader.JSONtoCSV(this.data)
    }
  },
  mounted() {},
  methods: {
    /** Reset to empty values */
    reset(uploadType) {
      this.uploadType = uploadType
      this.data = []
      this.headers = []
      this.$refs.pond.removeFile()
    },
    /**
     * Read spreadsheets file, parsed into JSON data
     * Set headers and data for data-table
     */
    loadFile() {
      const self = this
      const files = this.$refs.pond.getFiles()
      // eslint-disable-next-line
      FReader.readExcel(files[0].file)
        .then(function(content) {
          // eslint-disable-next-line
          self.headers = Object.keys(content[0]).map((o) => ({
            text: o,
            value: o,
            sortable: true
          }))
          // eslint-disable-next-line
          setTimeout(() => {
            self.data = content
          }, 200)
        })
        .catch((error) => {
          // eslint-disable-next-line
          console.error(error)
        })
    },
    /**
     * Parse pasted data into JSON object array
     * Set headers and data for data-tables
     */
    parsePastedData() {
      const self = this
      self.loading = true
      self.data = []
      self.headers = []
      const data = self.pastedData
      const rows = data.split('\n')
      let headers = []
      for (const y in rows) {
        const cells = rows[y].split('\t')
        if (+y === 0) {
          /** First row, used for headers */
          headers = cells
          /** Generate headers for data-table */
          self.headers = headers.map((o) => ({
            text: o,
            value: o
              .toLowerCase()
              .split(' ')
              .join('_'),
            sortable: true
          }))
        } else {
          /** Parse pasted rows to JSON objects */
          const cellObj = cells.reduce(
            (previousObject, currentValue, currentIndex) => {
              const key = headers[currentIndex]
                .toLowerCase()
                .split(' ')
                .join('_')
              const value = currentValue
              return Object.assign(previousObject, {
                [key]: value
              })
            },
            {}
          )
          if (
            !self.data[0] ||
            Object.keys(cellObj).length >= Object.keys(self.data[0]).length
          ) {
            self.data.push(cellObj)
          }
        }
      }
      /** Reset pastedData */
      self.pastedData = ''
      self.loading = false
    },
    certificate() {
      if (this.data.length > 0) {
        this.selected.forEach((item) => {
          this.dialogValidate = false
          this.$firebase
            .firestore()
            .collection('certificateDataCollection')
            .add(item)
            .then(() => {
              // eslint-disable-next-line
              this.$router.push({
                path: '/certificate-data'
              })
            })
        })
      }
    }
  }
}
</script>
<style lang="scss" scoped>
textarea {
  border: solid 2px #666;
  width: 100%;
  height: 200px;
}
.table-title {
  align-items: center;
  display: inline-flex;
  width: 50%;
}
@media (min-width: 1904px) {
  .container {
    max-width: 1264px;
  }
}
</style>
